<template>
    <div class="map absolute left-0 top-0 w-full h-full">
        <div ref="canvas" class="absolute w-full h-full left-0 top-0 z-10">
            <l-map :center="center" :zoom="13" :options="options" v-on:click="click" ref="map">
                <l-circle-marker v-if="found.coordinate" :lat-lng="found.coordinate" :radius="10" color="blue" fillColor='blue'></l-circle-marker>
                <l-tile-layer :url="url" :attribution="attribution" :options="{maxZoom: 20}"></l-tile-layer>
                <l-marker v-if="captured" :lat-lng="captured" :icon="capturedIcon"></l-marker>
            </l-map>
        </div>
        <div class="locate flex flex-col absolute left-0 h-auto min-w-64 z-20 my-4 mx-12 z-10">
            <div class="search">
                <div class="editor relative">
                    <input v-model="keyword" type="text" name="keyword" class="text-md w-full rounded-r-lg rounded-bl-lg px-2 py-2" placeholder="search..." v-on:keyup.enter="search" />
                    <img src="./pix/gear.gif" class="absolute right-0 top-0 w-8 mt-1 mr-2" v-if="searching" style="right: 38px;" />
                    <button title="clear" class="absolute right-0 top-0 w-8 mt-1 mr-2" v-on:click="clearSearch">
                        <svg enable-background="new 0 0 320.941 320.941" viewBox="0 0 320.941 320.941" xmlns="http://www.w3.org/2000/svg"><path d="m290.853 40.118h-181.049c-9.06 0-17.551 4.016-23.301 11.038l-84.241 102.968c-3.017 3.692-3.017 9.001 0 12.693l84.251 102.978c5.739 7.013 14.231 11.028 23.291 11.028h181.048c16.592 0 30.088-13.497 30.088-30.088v-180.529c.001-16.592-13.496-30.088-30.087-30.088zm10.029 210.617c0 5.534-4.496 10.029-10.029 10.029h-181.049c-3.026 0-5.857-1.342-7.767-3.673l-79.05-96.621 79.04-96.611c1.92-2.341 4.75-3.683 7.777-3.683h181.048c5.534 0 10.029 4.496 10.029 10.029.001.001.001 180.53.001 180.53z"/><path d="m223.585 103.232-43.056 43.056-43.056-43.056-14.182 14.182 43.056 43.056-43.056 43.056 14.182 14.182 43.056-43.056 43.056 43.056 14.182-14.182-43.056-43.056 43.056-43.056z"/></svg>
                    </button>
                </div>
                <div class="results bg-white">
                    <div class="result border-b-2 border-gray-200 cursor-pointer px-2 py-1 w-full hover:bg-gray-200" v-for="result in results" v-on:click="go(result)">
                        <div class="place text-sm">{{result.name}}</div>
                        <div class="provider text-xs text-gray-400">{{result.provider}}</div>
                    </div>
                </div>
            </div>
        </div>
        <div class="captured flex flex-col absolute bottom-0 left-0 h-auto z-20 p-1 bg-black text-white bg-opacity-50 rounded-sm z-10">
            <div v-if="value" class="captured text-xs flex flex-row pl-2">
                <div class="mr-1">{{value.lat.toFixed(6)}}</div>
                <div class="ml-1">{{value.lng.toFixed(6)}}</div>
            </div>
        </div>
    </div>
</template>
<script>
    import Vue from 'vue'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import { LMap, LMarker, LCircleMarker, LTileLayer } from 'vue2-leaflet';
    import 'leaflet/dist/leaflet.css';
    import './style.css'
    
    delete L.Icon.Default.prototype._getIconUrl;

    L.Icon.Default.mergeOptions({
        iconRetinaUrl: require('leaflet/dist/images/marker-icon-2x.png'),
        iconUrl: require('leaflet/dist/images/marker-icon.png'),
        shadowUrl: require('leaflet/dist/images/marker-shadow.png'),
    });
    
    export default {
        name: "WeeSpatialSpatialMiniMap",
        props: ['value'],
        data: function(){
            let self = this;
            return {
                center: this.value,
                // url: 'https://api.mapbox.com/styles/v1/neel-basu/ck9tuop9y04tl1il1sj4mw7p2/tiles/{z}/{x}/{y}?access_token='+MAPBOX_ACCESS_TOKEN,
                url: 'https://mt0.google.com/vt/lyrs=m&x={x}&y={y}&z={z}', // google
                // subdomains:['mt0','mt1','mt2','mt3'], // google
                // attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
                attribution: 'Map data ©2019 Google', // Google
                searching: false,
                options: { maxZoom: 20 },
                results: [],
                captured: this.value,
                found : {
                    coordinate: null,
                    name: ''
                },
                capturedIcon: L.icon({
                    iconUrl: '/components/pix/zond/pin.svg',
                    iconSize: [32, 37],
                    iconAnchor: [16, 37]
                }),
                capturingIcon: L.icon({
                    iconUrl: require('./pix/ball.gif'),
                    iconSize: [32, 37],
                    iconAnchor: [16, 37]
                })
            };
        },
        created(){
            console.log('value', this.value);
        },
        components: {
            LMap,
            LMarker,
            LCircleMarker,
            LTileLayer
        },
        methods: {
            search(){
                let self = this;
                this.searching = true;
                axios.get(this.searchUrl+this.keyword).then(function(response){
                    self.results = response.data.results;
                    self.searching = false;
                }).catch((thrown) => function(){
                    self.searching = false;
                });
            },
            clearSearch(){
                this.results = [];
                this.keyword = "";
                this.found.coordinate = null;
            },
            go(result){
                this.found = result;
                this.focus(result.coordinate);
            },
            focus(coordinate){
                this.$refs.map.mapObject.flyTo(coordinate, 18);
            },
            click(e){
                this.captured = e.latlng;
                this.$emit('input', this.captured);
            }
        },
        computed: {
            searchUrl(){
                return "/spatial/search/";
            }
        }
    }
</script>
<style>
.canvas{
    width: 100%;
    height: 100%;
}
</style>
